Subject: Re: [PATCH] net: packet: option to only pass skb protocol

From: Eric Dumazet <[email-masked]>
Date: Tue, 05 Jan 2010 20:27:21 +0100

Le 05/01/2010 19:57, Michael S. Tsirkin a écrit :
> When sending packets with a packet socket it is often necessary to set
> protocol in msg_name: otherwise the protocol field in the skb will not
> be set correctly.  However, currently doing this also requires
> supplying the interface index.
> 
> The following patch makes it possible to avoid supplying the interface
> index by interpreting index 0 as "use device this socket is bound to".
> 

Patch is correct, but I dont understand why zero initialization by caller
is any better then supplying ifindex (known when socket was bound to device ?)

To avoid one syscall at socket setup (to get ifindex from dev name),
you prefer to add a test/branch at each send() syscall...

Am I missing something ?